#ifndef INC_CalcParser_hpp_
#define INC_CalcParser_hpp_

#line 2 "calc.g"

#include <cmath>
#include <map>
#include <string>
class CMobile;
#include "atr_nfo.h"

#line 13 "CalcParser.hpp"
#include <antlr/config.hpp>
/* $ANTLR 2.7.3rc2: "calc.g" -> "CalcParser.hpp"$ */
#include <antlr/TokenStream.hpp>
#include <antlr/TokenBuffer.hpp>
#include "CalcWalkerTokenTypes.hpp"
#include <antlr/LLkParser.hpp>

class CUSTOM_API CalcParser : public ANTLR_USE_NAMESPACE(antlr)LLkParser, public CalcWalkerTokenTypes
{
#line 1 "calc.g"
#line 24 "CalcParser.hpp"
public:
	void initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& factory );
protected:
	CalcParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf, int k);
public:
	CalcParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf);
protected:
	CalcParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer, int k);
public:
	CalcParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer);
	CalcParser(const ANTLR_USE_NAMESPACE(antlr)ParserSharedInputState& state);
	int getNumTokens() const
	{
		return CalcParser::NUM_TOKENS;
	}
	const char* getTokenName( int type ) const
	{
		if( type > getNumTokens() ) return 0;
		return CalcParser::tokenNames[type];
	}
	const char* const* getTokenNames() const
	{
		return CalcParser::tokenNames;
	}
	public: void start();
	public: void expr();
	public: void isolated_start();
	public: void fullref();
	public: void lvalue();
	public: void fexpr();
	public: void ref();
	public: void localref();
	public: void attribute();
	public: void logicexpr();
	public: void addexpr();
	public: void mexpr();
	public: void atom();
	public: void float_();
public:
	ANTLR_USE_NAMESPACE(antlr)RefAST getAST()
	{
		return returnAST;
	}
	
protected:
	ANTLR_USE_NAMESPACE(antlr)RefAST returnAST;
private:
	static const char* tokenNames[];
#ifndef NO_STATIC_CONSTS
	static const int NUM_TOKENS = 129;
#else
	enum {
		NUM_TOKENS = 129
	};
#endif
	
	static const unsigned long _tokenSet_0_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_0;
	static const unsigned long _tokenSet_1_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_1;
	static const unsigned long _tokenSet_2_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_2;
	static const unsigned long _tokenSet_3_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_3;
	static const unsigned long _tokenSet_4_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_4;
	static const unsigned long _tokenSet_5_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_5;
};

#endif /*INC_CalcParser_hpp_*/
