#include "antlr/AST.hpp"
#include "MyASTNode.h"
using namespace antlr;

// intialize static var

MyASTNode::MyASTNode() {}

int MyASTNode::getLine() const
{ // fprintf(stderr,"return %d\n",_line);
   return _line;   
}

void MyASTNode::initialize(RefToken t) {
  CommonAST::initialize(t);
  _line = t->getLine();
  //fprintf(stderr,"init %d\n",_line);
}

 antlr::RefAST MyASTNode::factory()
{ return RefAST(new MyASTNode); }
